libssh: The libssh server API

libssh 0.12.1 The SSH library

Loading...
Searching...
No Matches
Data Structures | Typedefs | Enumerations | Functions
The libssh server API

## Data Structures
struct | ssh_bind_callbacks_struct
| These are the callbacks exported by the ssh_bind structure. More...

## Typedefs
typedef void(* | ssh_bind_incoming_connection_callback) (ssh_bind sshbind, void *userdata)
| Incoming connection callback. This callback is called when a ssh_bind has a new incoming connection.

## Enumerations
enum | ssh_bind_options_e { SSH_BIND_OPTIONS_BINDADDR , SSH_BIND_OPTIONS_BINDPORT , SSH_BIND_OPTIONS_BINDPORT_STR , SSH_BIND_OPTIONS_HOSTKEY , SSH_BIND_OPTIONS_DSAKEY , SSH_BIND_OPTIONS_RSAKEY , SSH_BIND_OPTIONS_BANNER , SSH_BIND_OPTIONS_LOG_VERBOSITY , SSH_BIND_OPTIONS_LOG_VERBOSITY_STR , SSH_BIND_OPTIONS_ECDSAKEY , SSH_BIND_OPTIONS_IMPORT_KEY , SSH_BIND_OPTIONS_KEY_EXCHANGE , SSH_BIND_OPTIONS_CIPHERS_C_S , SSH_BIND_OPTIONS_CIPHERS_S_C , SSH_BIND_OPTIONS_HMAC_C_S , SSH_BIND_OPTIONS_HMAC_S_C , SSH_BIND_OPTIONS_CONFIG_DIR , SSH_BIND_OPTIONS_PUBKEY_ACCEPTED_KEY_TYPES , SSH_BIND_OPTIONS_HOSTKEY_ALGORITHMS , SSH_BIND_OPTIONS_PROCESS_CONFIG , SSH_BIND_OPTIONS_MODULI , SSH_BIND_OPTIONS_RSA_MIN_SIZE , SSH_BIND_OPTIONS_IMPORT_KEY_STR , SSH_BIND_OPTIONS_GSSAPI_KEY_EXCHANGE , SSH_BIND_OPTIONS_GSSAPI_KEY_EXCHANGE_ALGS }

## Functions
LIBSSH_API ssh_bind | ssh_bind_new (void)
| Creates a new SSH server bind.
LIBSSH_API int | ssh_bind_options_set (ssh_bind sshbind, enum ssh_bind_options_e type, const void *value)
| Set options for an SSH server bind.
LIBSSH_API int | ssh_bind_options_parse_config (ssh_bind sshbind, const char *filename)
| Parse a ssh bind options configuration file.
LIBSSH_API int | ssh_bind_listen (ssh_bind ssh_bind_o)
| Start listening to the socket.
LIBSSH_API int | ssh_bind_set_callbacks (ssh_bind sshbind, ssh_bind_callbacks callbacks, void *userdata)
| Set the callback for this bind.
LIBSSH_API void | ssh_bind_set_blocking (ssh_bind ssh_bind_o, int blocking)
| Set the session to blocking/nonblocking mode.
LIBSSH_API socket_t | ssh_bind_get_fd (ssh_bind ssh_bind_o)
| Recover the file descriptor from the session.
LIBSSH_API void | ssh_bind_set_fd (ssh_bind ssh_bind_o, socket_t fd)
| Set the file descriptor for a session.
LIBSSH_API void | ssh_bind_fd_toaccept (ssh_bind ssh_bind_o)
| Allow the file descriptor to accept new sessions.
LIBSSH_API int | ssh_bind_accept (ssh_bind ssh_bind_o, ssh_session session)
| Accept an incoming ssh connection and initialize the session.
LIBSSH_API int | ssh_bind_accept_fd (ssh_bind ssh_bind_o, ssh_session session, socket_t fd)
| Accept an incoming ssh connection on the given file descriptor and initialize the session.
LIBSSH_API ssh_gssapi_creds | ssh_gssapi_get_creds (ssh_session session)
| returns the client credentials of the connected client. If the client has given a forwardable token, the SSH server will retrieve it.
LIBSSH_API int | ssh_handle_key_exchange (ssh_session session)
| Handles the key exchange and set up encryption.
LIBSSH_API int | ssh_server_init_kex (ssh_session session)
| Initialize the set of key exchange, hostkey, ciphers, MACs, and compression algorithms for the given ssh_session.
LIBSSH_API void | ssh_bind_free (ssh_bind ssh_bind_o)
| Free a ssh servers bind.
LIBSSH_API void | ssh_set_auth_methods (ssh_session session, int auth_methods)
| Set the acceptable authentication methods to be sent to the client.
LIBSSH_API int | ssh_send_issue_banner (ssh_session session, const ssh_string banner)
| Send the server's issue-banner to client.
LIBSSH_API int | ssh_message_reply_default (ssh_message msg)
| Reply with a standard reject message.
LIBSSH_API const char * | ssh_message_auth_user (ssh_message msg)
| Get the name of the authenticated user.
SSH_DEPRECATED LIBSSH_API const char * | ssh_message_auth_password (ssh_message msg)
| Get the password of the authenticated user.
SSH_DEPRECATED LIBSSH_API ssh_key | ssh_message_auth_pubkey (ssh_message msg)
| Get the publickey of the authenticated user.
LIBSSH_API int | ssh_message_auth_kbdint_is_response (ssh_message msg)
| Check if the message is a keyboard-interactive response.
SSH_DEPRECATED LIBSSH_API enum ssh_publickey_state_e | ssh_message_auth_publickey_state (ssh_message msg)
LIBSSH_API int | ssh_message_auth_reply_success (ssh_message msg, int partial)
| Replies to an authentication request with success.
LIBSSH_API int | ssh_message_auth_reply_pk_ok (ssh_message msg, ssh_string algo, ssh_string pubkey)
| Answer SSH2_MSG_USERAUTH_PK_OK to a pubkey authentication request.
LIBSSH_API int | ssh_message_auth_reply_pk_ok_simple (ssh_message msg)
| Answer SSH2_MSG_USERAUTH_PK_OK to a pubkey authentication request.
LIBSSH_API int | ssh_message_auth_set_methods (ssh_message msg, int methods)
| Sets the supported authentication methods to a message.
LIBSSH_API int | ssh_message_auth_interactive_request (ssh_message msg, const char *name, const char *instruction, unsigned int num_prompts, const char **prompts, char *echo)
| Sends an interactive authentication request message.
LIBSSH_API int | ssh_message_service_reply_success (ssh_message msg)
| Sends SSH2_MSG_SERVICE_ACCEPT to the client.
LIBSSH_API const char * | ssh_message_service_service (ssh_message msg)
| Gets the service name from the service request message.
LIBSSH_API int | ssh_message_global_request_reply_success (ssh_message msg, uint16_t bound_port)
| Send a global request success message.
LIBSSH_API void | ssh_set_message_callback (ssh_session session, int(*ssh_bind_message_callback)(ssh_session session, ssh_message msg, void *data), void *data)
| defines the ssh_message callback
LIBSSH_API int | ssh_execute_message_callbacks (ssh_session session)
| Execute callbacks for the messages in the queue.
LIBSSH_API const char * | ssh_message_channel_request_open_originator (ssh_message msg)
| Get the originator address from the channel open message.
LIBSSH_API int | ssh_message_channel_request_open_originator_port (ssh_message msg)
| Get the originator port from the channel open message.
LIBSSH_API const char * | ssh_message_channel_request_open_destination (ssh_message msg)
| Get the destination address from the channel open message.
LIBSSH_API int | ssh_message_channel_request_open_destination_port (ssh_message msg)
| Get the destination port from the channel open message.
LIBSSH_API ssh_channel | ssh_message_channel_request_channel (ssh_message msg)
| Get the channel associated with the message.
SSH_DEPRECATED LIBSSH_API const char * | ssh_message_channel_request_pty_term (ssh_message msg)
| Get the terminal type from the message.
SSH_DEPRECATED LIBSSH_API int | ssh_message_channel_request_pty_width (ssh_message msg)
| Get the terminal width from the message.
SSH_DEPRECATED LIBSSH_API int | ssh_message_channel_request_pty_height (ssh_message msg)
| Get the terminal height from the message.
SSH_DEPRECATED LIBSSH_API int | ssh_message_channel_request_pty_pxwidth (ssh_message msg)
| Get the terminal pixel width from the message.
SSH_DEPRECATED LIBSSH_API int | ssh_message_channel_request_pty_pxheight (ssh_message msg)
| Get the terminal pixel height from the message.
LIBSSH_API const char * | ssh_message_channel_request_env_name (ssh_message msg)
| Get the name of the environment variable from the message.
LIBSSH_API const char * | ssh_message_channel_request_env_value (ssh_message msg)
| Get the value of the environment variable from the message.
LIBSSH_API const char * | ssh_message_channel_request_command (ssh_message msg)
| Get the command from a channel request message.
LIBSSH_API const char * | ssh_message_channel_request_subsystem (ssh_message msg)
| Get the subsystem from a channel request message.
SSH_DEPRECATED LIBSSH_API int | ssh_message_channel_request_x11_single_connection (ssh_message msg)
| Check if the X11 request is for a single connection.
SSH_DEPRECATED LIBSSH_API const char * | ssh_message_channel_request_x11_auth_protocol (ssh_message msg)
| Get the X11 authentication protocol from the message.
SSH_DEPRECATED LIBSSH_API const char * | ssh_message_channel_request_x11_auth_cookie (ssh_message msg)
| Get the X11 authentication cookie from the message.
SSH_DEPRECATED LIBSSH_API int | ssh_message_channel_request_x11_screen_number (ssh_message msg)
| Get the X11 screen number from the message.
LIBSSH_API const char * | ssh_message_global_request_address (ssh_message msg)
| Get the bind address from the global request message.
LIBSSH_API int | ssh_message_global_request_port (ssh_message msg)
| Get the bind port from the global request message.
LIBSSH_API int | ssh_channel_open_reverse_forward (ssh_channel channel, const char *remotehost, int remoteport, const char *sourcehost, int localport)
| Open a TCP/IP reverse forwarding channel.
LIBSSH_API int | ssh_channel_open_x11 (ssh_channel channel, const char *orig_addr, int orig_port)
| Open a X11 channel.
LIBSSH_API int | ssh_channel_request_send_exit_status (ssh_channel channel, int exit_status)
| Send the exit status to the remote process.
LIBSSH_API int | ssh_channel_request_send_exit_signal (ssh_channel channel, const char *signum, int core, const char *errmsg, const char *lang)
| Send an exit signal to remote process (RFC 4254, section 6.10).
LIBSSH_API int | ssh_send_keepalive (ssh_session session)
| Sends a keepalive message to the session.
SSH_DEPRECATED LIBSSH_API int | ssh_accept (ssh_session session)
SSH_DEPRECATED LIBSSH_API int | channel_write_stderr (ssh_channel channel, const void *data, uint32_t len)
ssh_poll_handle | ssh_bind_get_poll (ssh_bind sshbind)
int | server_set_kex (ssh_session session)
| SSH_PACKET_CALLBACK (ssh_packet_kexdh_init)
int | ssh_get_key_params (ssh_session session, ssh_key *privkey, enum ssh_digest_e *digest)
| Prepares server host key parameters for the key exchange process.
int | ssh_auth_reply_default (ssh_session session, int partial)
ssh_public_key | ssh_message_auth_publickey (ssh_message msg)
int | ssh_auth_reply_success (ssh_session session, int partial)
| Sends SSH2_MSG_USERAUTH_SUCCESS or SSH2_MSG_USERAUTH_FAILURE message depending on the success of the authentication method.

## Detailed Description

## Typedef Documentation

## ◆ ssh_bind_incoming_connection_callback

typedef void(* ssh_bind_incoming_connection_callback) (ssh_bind sshbind, void *userdata)

Incoming connection callback. This callback is called when a ssh_bind has a new incoming connection.

Parameters

  sshbind | Current sshbind session handler
  userdata | Userdata to be passed to the callback function.

## Function Documentation

## ◆ ssh_auth_reply_success()

int ssh_auth_reply_success | ( | ssh_session | session,
|  | int | partial )

Sends SSH2_MSG_USERAUTH_SUCCESS or SSH2_MSG_USERAUTH_FAILURE message depending on the success of the authentication method.

Parameters

  session | The session to reply to
  partial | Denotes if the authentication process was partially completed (unsuccessful)

Returns
  SSH_OK on success, otherwise SSH_ERROR

## ◆ ssh_bind_accept()

int ssh_bind_accept | ( | ssh_bind | ssh_bind_o,
|  | ssh_session | session )

Accept an incoming ssh connection and initialize the session.

Parameters

  ssh_bind_o | The ssh server bind to accept a connection.
  session | A preallocated ssh session

See also
  ssh_new

Returns
  SSH_OK when a connection is established

## ◆ ssh_bind_accept_fd()

int ssh_bind_accept_fd | ( | ssh_bind | ssh_bind_o,
|  | ssh_session | session,
|  | socket_t | fd )

Accept an incoming ssh connection on the given file descriptor and initialize the session.

Parameters

  ssh_bind_o | The ssh server bind to accept a connection.
  session | A preallocated ssh session
  fd | A file descriptor of an already established TCP inbound connection

See also
  ssh_new
  ssh_bind_accept

Returns
  SSH_OK when a connection is established

## ◆ ssh_bind_fd_toaccept()

void ssh_bind_fd_toaccept | ( | ssh_bind | ssh_bind_o | ) |

Allow the file descriptor to accept new sessions.

Parameters

  ssh_bind_o | The ssh server bind to use.

## ◆ ssh_bind_free()

void ssh_bind_free | ( | ssh_bind | ssh_bind_o | ) |

Free a ssh servers bind.

Note that this will also free options that have been set on the bind, including keys set with SSH_BIND_OPTIONS_IMPORT_KEY.

Parameters

  ssh_bind_o | The ssh server bind to free.

## ◆ ssh_bind_get_fd()

socket_t ssh_bind_get_fd | ( | ssh_bind | ssh_bind_o | ) |

Recover the file descriptor from the session.

Parameters

  ssh_bind_o | The ssh server bind to get the fd from.

Returns
  The file descriptor.

## ◆ ssh_bind_listen()

int ssh_bind_listen | ( | ssh_bind | ssh_bind_o | ) |

Start listening to the socket.

Parameters

  ssh_bind_o | The ssh server bind to use.

Returns
  0 on success, < 0 on error.

## ◆ ssh_bind_new()

ssh_bind ssh_bind_new | ( | void |  | ) |

Creates a new SSH server bind.

Returns
  A newly allocated ssh_bind session pointer.

## ◆ ssh_bind_options_parse_config()

int ssh_bind_options_parse_config | ( | ssh_bind | sshbind,
|  | const char * | filename )

Parse a ssh bind options configuration file.

This parses the options file and set them to the ssh_bind handle provided. If an option was previously set, it is overridden. If the global configuration hasn't been processed yet, it is processed prior to the provided file.

Parameters

  sshbind | SSH bind handle
  filename | The options file to use; if NULL only the global configuration is parsed and applied (if it hasn't been processed before).

Returns
  0 on success, < 0 on error.

## ◆ ssh_bind_options_set()

int ssh_bind_options_set | ( | ssh_bind | sshbind,
|  | enum ssh_bind_options_e | type,
|  | const void * | value )

Set options for an SSH server bind.

Parameters

  sshbind | The ssh server bind to configure.
  type | The option type to set. This should be one of the following:

- SSH_BIND_OPTIONS_HOSTKEY: Set the path to an ssh host key, regardless of type. Only one key from per key type (RSA, ED25519 and ECDSA) is allowed in an ssh_bind at a time, and later calls to this function with this option for the same key type will override prior calls (const char *).
- SSH_BIND_OPTIONS_BINDADDR: Set the IP address to bind (const char *).
- SSH_BIND_OPTIONS_BINDPORT: Set the port to bind (unsigned int).
- SSH_BIND_OPTIONS_BINDPORT_STR: Set the port to bind (const char *).
- SSH_BIND_OPTIONS_LOG_VERBOSITY: Set the session logging verbosity (int). The logging verbosity should have one of the following values, which are listed in order of increasing verbosity. Every log message with verbosity less than or equal to the logging verbosity will be shown.
  - SSH_LOG_NOLOG: No logging
  - SSH_LOG_WARNING: Only warnings
  - SSH_LOG_PROTOCOL: High level protocol information
  - SSH_LOG_PACKET: Lower level protocol information, packet level
  - SSH_LOG_FUNCTIONS: Every function path The default is SSH_LOG_NOLOG.
- SSH_BIND_OPTIONS_LOG_VERBOSITY_STR: Set the session logging verbosity via a string that will be converted to a numerical value (e.g. "3") and interpreted according to the values of SSH_BIND_OPTIONS_LOG_VERBOSITY above (const char *).
- SSH_BIND_OPTIONS_RSAKEY: Deprecated alias to SSH_BIND_OPTIONS_HOSTKEY (const char *).
- SSH_BIND_OPTIONS_ECDSAKEY: Deprecated alias to SSH_BIND_OPTIONS_HOSTKEY (const char *).
- SSH_BIND_OPTIONS_BANNER: Set the server banner sent to clients (const char *).
- SSH_BIND_OPTIONS_DSAKEY: This is DEPRECATED, please do not use.
- SSH_BIND_OPTIONS_IMPORT_KEY: Set the Private Key for the server directly (ssh_key). It will be free'd by ssh_bind_free().
- SSH_BIND_OPTIONS_IMPORT_KEY_STR: Set the Private key for the server from a base64 encoded buffer (const char *).
- SSH_BIND_OPTIONS_CIPHERS_C_S: Set the symmetric cipher client to server (const char *, comma-separated list).
- SSH_BIND_OPTIONS_CIPHERS_S_C: Set the symmetric cipher server to client (const char *, comma-separated list).
- SSH_BIND_OPTIONS_KEY_EXCHANGE: Set the key exchange method to be used (const char *, comma-separated list). ex: "ecdh-sha2-nistp256,diffie-hellman-group14-sha1"
- SSH_BIND_OPTIONS_HMAC_C_S: Set the Message Authentication Code algorithm client to server (const char *, comma-separated list).
- SSH_BIND_OPTIONS_HMAC_S_C: Set the Message Authentication Code algorithm server to client (const char *, comma-separated list).
- SSH_BIND_OPTIONS_CONFIG_DIR: Set the directory (const char *, format string) to be used when the "%d" scape is used when providing paths of configuration files to ssh_bind_options_parse_config().
- SSH_BIND_OPTIONS_PROCESS_CONFIG Set it to false to disable automatic processing of system-wide configuration files. LibSSH automatically uses these configuration files otherwise. This option will only have effect if set before any call to ssh_bind_options_parse_config() (bool).
- SSH_BIND_OPTIONS_PUBKEY_ACCEPTED_KEY_TYPES: Set the public key algorithm accepted by the server (const char *, comma-separated list).
- SSH_BIND_OPTIONS_HOSTKEY_ALGORITHMS: Set the list of allowed hostkey signatures algorithms to offer to the client, ordered by preference. This list is used as a filter when creating the list of algorithms to offer to the client: first the list of possible algorithms is created from the list of keys set and then filtered against this list. (const char *, comma-separated list).
- SSH_BIND_OPTIONS_MODULI Set the path to the moduli file. Defaults to /etc/ssh/moduli if not specified (const char *).
- SSH_BIND_OPTIONS_RSA_MIN_SIZE Set the minimum RSA key size in bits to be accepted by the server for both authentication and hostkey operations. The values under 1024 bits are not accepted even with this configuration option as they are considered completely broken. Setting 0 will revert the value to defaults. Default is 3072 bits or 2048 bits in FIPS mode. (int)
- SSH_BIND_OPTIONS_GSSAPI_KEY_EXCHANGE Set true to enable GSSAPI key exchange, false to disable GSSAPI key exchange. (bool)
- SSH_BIND_OPTIONS_GSSAPI_KEY_EXCHANGE_ALGS Set the GSSAPI key exchange method to be used (const char *, comma-separated list). ex: "gss-group14-sha256-,gss-group16-sha512-"

Parameters

  value | The value to set. This is a generic pointer and the datatype which should be used is described at the corresponding value of type above.

Returns
  0 on success, < 0 on error, invalid option, or parameter.

Warning
  When the option value to set is represented via a pointer (e.g const char * in case of strings, ssh_key in case of a libssh key), the value parameter should be that pointer. Do NOT pass a pointer to a pointer (const char **, ssh_key *)
  When the option value to set is not a pointer (e.g int, unsigned int, bool, long), the value parameter should be a pointer to the location storing the value to set (int *, unsigned int *, bool *, long *)
  If the value parameter has an invalid type (e.g if its not a pointer when it should have been a pointer, or if its a pointer to a pointer when it should have just been a pointer), then the behaviour is undefined.

## ◆ ssh_bind_set_blocking()

void ssh_bind_set_blocking | ( | ssh_bind | ssh_bind_o,
|  | int | blocking )

Set the session to blocking/nonblocking mode.

Parameters

  ssh_bind_o | The ssh server bind to use.
  blocking | Zero for nonblocking mode.

## ◆ ssh_bind_set_callbacks()

int ssh_bind_set_callbacks | ( | ssh_bind | sshbind,
|  | ssh_bind_callbacks | callbacks,
|  | void * | userdata )

Set the callback for this bind.

Parameters

  [in] | sshbind | The bind to set the callback on.
  [in] | callbacks | An already set up ssh_bind_callbacks instance.
  [in] | userdata | A pointer to private data to pass to the callbacks.

Returns
  SSH_OK on success, SSH_ERROR if an error occurred.

struct ssh_callbacks_struct cb = {
.userdata = data,
.auth_function = my_auth_function
};
ssh_callbacks_init(&cb);
ssh_bind_set_callbacks(session, &cb);
ssh_callbacks_init
#define ssh_callbacks_init(p)
Initializes an ssh_callbacks_struct A call to this macro is mandatory when you have set a new ssh_cal...
Definition callbacks.h:515
ssh_bind_set_callbacks
LIBSSH_API int ssh_bind_set_callbacks(ssh_bind sshbind, ssh_bind_callbacks callbacks, void *userdata)
Set the callback for this bind.
Definition bind.c:287
ssh_callbacks_struct
Definition callbacks.h:176

## ◆ ssh_bind_set_fd()

void ssh_bind_set_fd | ( | ssh_bind | ssh_bind_o,
|  | socket_t | fd )

Set the file descriptor for a session.

Parameters

  ssh_bind_o | The ssh server bind to set the fd.
  fd | The file descriptssh_bind B

## ◆ ssh_channel_open_reverse_forward()

LIBSSH_API int ssh_channel_open_reverse_forward | ( | ssh_channel | channel,
|  | const char * | remotehost,
|  | int | remoteport,
|  | const char * | sourcehost,
|  | int | localport )

Open a TCP/IP reverse forwarding channel.

Parameters

  [in] | channel | An allocated channel.
  [in] | remotehost | The remote host to connected (host name or IP).
  [in] | remoteport | The remote port.
  [in] | sourcehost | The source host (your local computer). It's optional and for logging purpose.
  [in] | localport | The source port (your local computer). It's optional and for logging purpose.

Returns
  SSH_OK on success, SSH_ERROR if an error occurred, SSH_AGAIN if in nonblocking mode and call has to be done again.

Warning
  This function does not bind the local port and does not automatically forward the content of a socket to the channel. You still have to use ssh_channel_read and ssh_channel_write for this.

## ◆ ssh_channel_open_x11()

LIBSSH_API int ssh_channel_open_x11 | ( | ssh_channel | channel,
|  | const char * | orig_addr,
|  | int | orig_port )

Open a X11 channel.

Parameters

  [in] | channel | An allocated channel.
  [in] | orig_addr | The source host (the local server).
  [in] | orig_port | The source port (the local server).

Returns
  SSH_OK on success, SSH_ERROR if an error occurred, SSH_AGAIN if in nonblocking mode and call has to be done again.

Warning
  This function does not bind the local port and does not automatically forward the content of a socket to the channel. You still have to use shh_channel_read and ssh_channel_write for this.

## ◆ ssh_channel_request_send_exit_signal()

LIBSSH_API int ssh_channel_request_send_exit_signal | ( | ssh_channel | channel,
|  | const char * | sig,
|  | int | core,
|  | const char * | errmsg,
|  | const char * | lang )

Send an exit signal to remote process (RFC 4254, section 6.10).

This sends the exit status of the remote process. Note, that remote system may not support signals concept. In such a case this request will be silently ignored.

Parameters

  [in] | channel | The channel to send signal.
  [in] | sig | The signal to send (without SIG prefix) (e.g. "TERM" or "KILL").
  [in] | core | A boolean to tell if a core was dumped
  [in] | errmsg | A CRLF explanation text about the error condition
  [in] | lang | The language used in the message (format: RFC 3066)

Returns
  SSH_OK on success, SSH_ERROR if an error occurred

## ◆ ssh_channel_request_send_exit_status()

LIBSSH_API int ssh_channel_request_send_exit_status | ( | ssh_channel | channel,
|  | int | exit_status )

Send the exit status to the remote process.

Sends the exit status to the remote process (as described in RFC 4254, section 6.10).

Parameters

  [in] | channel | The channel to send exit status.
  [in] | exit_status | The exit status to send

Returns
  SSH_OK on success, SSH_ERROR if an error occurred.

## ◆ ssh_execute_message_callbacks()

int ssh_execute_message_callbacks | ( | ssh_session | session | ) |

Execute callbacks for the messages in the queue.

Parameters

  [in] | session | The session.

Returns
  SSH_OK on success, SSH_ERROR on error.

## ◆ ssh_get_key_params()

int ssh_get_key_params | ( | ssh_session | session,
|  | ssh_key * | privkey,
|  | enum ssh_digest_e * | digest )

Prepares server host key parameters for the key exchange process.

Selects the appropriate private host key (RSA, ECDSA, or Ed25519) based on the session's configured host key type, sets the corresponding `digest` algorithm, and imports the public key blob into the Diffie-Hellman key exchange state.

Parameters

  [in] | session | The SSH session to which we are preparing host key parameters.
  [out] | privkey | Pointer to receive the selected private host key.
  [out] | digest | Pointer to receive the host key digest algorithm.

Returns
  SSH_OK on success; SSH_ERROR on failure (invalid key type, export failure, or DH import error).

## ◆ ssh_gssapi_get_creds()

LIBSSH_API ssh_gssapi_creds ssh_gssapi_get_creds | ( | ssh_session | session | ) |

returns the client credentials of the connected client. If the client has given a forwardable token, the SSH server will retrieve it.

Returns
  gssapi credentials handle.
  NULL if no forwardable token is available.

## ◆ ssh_handle_key_exchange()

int ssh_handle_key_exchange | ( | ssh_session | session | ) |

Handles the key exchange and set up encryption.

Parameters

  session | A connected ssh session

See also
  ssh_bind_accept

Returns
  SSH_OK if the key exchange was successful

## ◆ ssh_message_auth_interactive_request()

int ssh_message_auth_interactive_request | ( | ssh_message | msg,
|  | const char * | name,
|  | const char * | instruction,
|  | unsigned int | num_prompts,
|  | const char ** | prompts,
|  | char * | echo )

Sends an interactive authentication request message.

Builds and sends an SSH2_MSG_USERAUTH_INFO_REQUEST packet containing the given name and `instruction`, followed by a number of `prompts` with associated `echo` flags to control whether user input is echoed. It initializes the keyboard-interactive state in the session.

Parameters

  [in] | msg | The SSH message representing the client authentication request.
  [in] | name | The name of the authentication request.
  [in] | instruction | Instruction string with information for the user.
  [in] | num_prompts | Number of prompts to send. The arrays prompts and echo must both have num_prompts elements.
  [in] | prompts | Array of `num_prompts` prompt strings to display.
  [in] | echo | Array of num_prompts boolean values (0 or 1). A non-zero value means the user input for that prompt is echoed (visible); 0 means the input is hidden (typically for passwords).

Returns
  SSH_OK on successful send; SSH_ERROR on failure.

## ◆ ssh_message_auth_kbdint_is_response()

int ssh_message_auth_kbdint_is_response | ( | ssh_message | msg | ) |

Check if the message is a keyboard-interactive response.

Parameters

  msg | The message to check

Returns
  1 if the message is a response, otherwise 0

## ◆ ssh_message_auth_password()

const char * ssh_message_auth_password | ( | ssh_message | msg | ) |

Get the password of the authenticated user.

Parameters

  [in] | msg | The message to get the password from.

Returns
  The password or NULL if an error occurred.

See also
  ssh_message_get()
  ssh_message_type()

Deprecated
  This function should not be used anymore as there is a callback based server implementation now auth_password_function.

## ◆ ssh_message_auth_pubkey()

ssh_key ssh_message_auth_pubkey | ( | ssh_message | msg | ) |

Get the publickey of the authenticated user.

If you need the key for later user you should duplicate it.

Parameters

  [in] | msg | The message to get the public key from.

Returns
  The public key or NULL.

See also
  ssh_key_dup()
  ssh_key_cmp()
  ssh_message_get()
  ssh_message_type()

Deprecated
  This function should not be used anymore as there is a callback based server implementation auth_pubkey_function.

## ◆ ssh_message_auth_publickey_state()

enum ssh_publickey_state_e ssh_message_auth_publickey_state | ( | ssh_message | msg | ) |

Parameters

  [in] | msg | The message to get the public key state from.

Deprecated
  This function should not be used anymore as there is a callback based server implementation auth_pubkey_function

## ◆ ssh_message_auth_reply_pk_ok()

int ssh_message_auth_reply_pk_ok | ( | ssh_message | msg,
|  | ssh_string | algo,
|  | ssh_string | pubkey )

Answer SSH2_MSG_USERAUTH_PK_OK to a pubkey authentication request.

Parameters

  msg | The message
  algo | The algorithm of the accepted public key
  pubkey | The accepted public key

Returns
  SSH_OK on success, otherwise SSH_ERROR

## ◆ ssh_message_auth_reply_pk_ok_simple()

int ssh_message_auth_reply_pk_ok_simple | ( | ssh_message | msg | ) |

Answer SSH2_MSG_USERAUTH_PK_OK to a pubkey authentication request.

Parameters

  msg | The message

Returns
  SSH_OK on success, otherwise SSH_ERROR

## ◆ ssh_message_auth_reply_success()

int ssh_message_auth_reply_success | ( | ssh_message | msg,
|  | int | partial )

Replies to an authentication request with success.

Sends an authentication success message (SSH2_MSG_USERAUTH_SUCCESS) to the client, or a partial success if further authentication steps are required.

Parameters

  [in] | msg | The SSH authentication message being handled.
  [in] | partial | Set to nonzero if partial success (more auth needed), zero for full success.

Returns
  SSH_OK on success, SSH_ERROR if msg is NULL or on send failure.

## ◆ ssh_message_auth_set_methods()

int ssh_message_auth_set_methods | ( | ssh_message | msg,
|  | int | methods )

Sets the supported authentication methods to a message.

Parameters

  msg | The message
  methods | Methods to set to the message. The supported methods are listed in ssh_set_auth_methods

See also
  ssh_set_auth_methods

Returns
  0 on success, otherwise -1

## ◆ ssh_message_auth_user()

const char * ssh_message_auth_user | ( | ssh_message | msg | ) |

Get the name of the authenticated user.

Parameters

  [in] | msg | The message to get the username from.

Returns
  The username or NULL if an error occurred.

See also
  ssh_message_get()
  ssh_message_type()

## ◆ ssh_message_channel_request_channel()

ssh_channel ssh_message_channel_request_channel | ( | ssh_message | msg | ) |

Get the channel associated with the message.

Parameters

  [in] | msg | The message.

Returns
  The channel associated with the message.

## ◆ ssh_message_channel_request_command()

const char * ssh_message_channel_request_command | ( | ssh_message | msg | ) |

Get the command from a channel request message.

Parameters

  [in] | msg | The message.

Returns
  The command, or NULL.

## ◆ ssh_message_channel_request_env_name()

const char * ssh_message_channel_request_env_name | ( | ssh_message | msg | ) |

Get the name of the environment variable from the message.

Parameters

  [in] | msg | The message.

Returns
  The variable name, or NULL.

## ◆ ssh_message_channel_request_env_value()

const char * ssh_message_channel_request_env_value | ( | ssh_message | msg | ) |

Get the value of the environment variable from the message.

Parameters

  [in] | msg | The message.

Returns
  The variable value, or NULL.

## ◆ ssh_message_channel_request_open_destination()

const char * ssh_message_channel_request_open_destination | ( | ssh_message | msg | ) |

Get the destination address from the channel open message.

Parameters

  [in] | msg | The message.

Returns
  The destination address, or NULL.

## ◆ ssh_message_channel_request_open_destination_port()

int ssh_message_channel_request_open_destination_port | ( | ssh_message | msg | ) |

Get the destination port from the channel open message.

Parameters

  [in] | msg | The message.

Returns
  The destination port.

## ◆ ssh_message_channel_request_open_originator()

const char * ssh_message_channel_request_open_originator | ( | ssh_message | msg | ) |

Get the originator address from the channel open message.

Parameters

  [in] | msg | The message.

Returns
  The originator address, or NULL.

## ◆ ssh_message_channel_request_open_originator_port()

int ssh_message_channel_request_open_originator_port | ( | ssh_message | msg | ) |

Get the originator port from the channel open message.

Parameters

  [in] | msg | The message.

Returns
  The originator port.

## ◆ ssh_message_channel_request_pty_height()

int ssh_message_channel_request_pty_height | ( | ssh_message | msg | ) |

Get the terminal height from the message.

Parameters

  [in] | msg | The message.

Returns
  The terminal height in characters.

Deprecated
  This function should not be used anymore as there is a callback based server implementation function channel_pty_request_function.

See also
  channel_pty_request_function.

## ◆ ssh_message_channel_request_pty_pxheight()

int ssh_message_channel_request_pty_pxheight | ( | ssh_message | msg | ) |

Get the terminal pixel height from the message.

Parameters

  [in] | msg | The message.

Returns
  The pixel height.

Deprecated
  This function should not be used anymore as there is a callback based server implementation function channel_pty_request_function.

See also
  channel_pty_request_function.

## ◆ ssh_message_channel_request_pty_pxwidth()

int ssh_message_channel_request_pty_pxwidth | ( | ssh_message | msg | ) |

Get the terminal pixel width from the message.

Parameters

  [in] | msg | The message.

Returns
  The pixel width.

Deprecated
  This function should not be used anymore as there is a callback based server implementation function channel_pty_request_function.

See also
  channel_pty_request_function.

## ◆ ssh_message_channel_request_pty_term()

const char * ssh_message_channel_request_pty_term | ( | ssh_message | msg | ) |

Get the terminal type from the message.

Parameters

  [in] | msg | The message.

Returns
  The terminal type (e.g. "xterm"), or NULL.

Deprecated
  This function should not be used anymore as there is a callback based server implementation function channel_pty_request_function.

See also
  channel_pty_request_function.

## ◆ ssh_message_channel_request_pty_width()

int ssh_message_channel_request_pty_width | ( | ssh_message | msg | ) |

Get the terminal width from the message.

Parameters

  [in] | msg | The message.

Returns
  The terminal width in characters.

Deprecated
  This function should not be used anymore as there is a callback based server implementation function channel_pty_request_function.

See also
  channel_pty_request_function.

## ◆ ssh_message_channel_request_subsystem()

const char * ssh_message_channel_request_subsystem | ( | ssh_message | msg | ) |

Get the subsystem from a channel request message.

Parameters

  [in] | msg | The message.

Returns
  The subsystem, or NULL.

## ◆ ssh_message_channel_request_x11_auth_cookie()

const char * ssh_message_channel_request_x11_auth_cookie | ( | ssh_message | msg | ) |

Get the X11 authentication cookie from the message.

Parameters

  [in] | msg | The message.

Returns
  The authentication cookie, or NULL.

Deprecated
  This function should not be used anymore as there is a callback based server implementation function channel_open_request_x11_function.

See also
  channel_open_request_x11_function.

## ◆ ssh_message_channel_request_x11_auth_protocol()

const char * ssh_message_channel_request_x11_auth_protocol | ( | ssh_message | msg | ) |

Get the X11 authentication protocol from the message.

Parameters

  [in] | msg | The message.

Returns
  The authentication protocol, or NULL.

Deprecated
  This function should not be used anymore as there is a callback based server implementation function channel_open_request_x11_function.

See also
  channel_open_request_x11_function.

## ◆ ssh_message_channel_request_x11_screen_number()

int ssh_message_channel_request_x11_screen_number | ( | ssh_message | msg | ) |

Get the X11 screen number from the message.

Parameters

  [in] | msg | The message.

Returns
  The screen number.

Deprecated
  This function should not be used anymore as there is a callback based server implementation function channel_open_request_x11_function.

See also
  channel_open_request_x11_function.

## ◆ ssh_message_channel_request_x11_single_connection()

int ssh_message_channel_request_x11_single_connection | ( | ssh_message | msg | ) |

Check if the X11 request is for a single connection.

Parameters

  [in] | msg | The message.

Returns
  1 if single connection, 0 otherwise.

Deprecated
  This function should not be used anymore as there is a callback based server implementation function channel_open_request_x11_function.

See also
  channel_open_request_x11_function.

## ◆ ssh_message_global_request_address()

const char * ssh_message_global_request_address | ( | ssh_message | msg | ) |

Get the bind address from the global request message.

Parameters

  [in] | msg | The message.

Returns
  The bind address, or NULL.

## ◆ ssh_message_global_request_port()

int ssh_message_global_request_port | ( | ssh_message | msg | ) |

Get the bind port from the global request message.

Parameters

  [in] | msg | The message.

Returns
  The bind port.

## ◆ ssh_message_global_request_reply_success()

int ssh_message_global_request_reply_success | ( | ssh_message | msg,
|  | uint16_t | bound_port )

Send a global request success message.

Parameters

  msg | The message
  bound_port | The remote bind port

Returns
  SSH_OK on success, otherwise SSH_ERROR

## ◆ ssh_message_reply_default()

int ssh_message_reply_default | ( | ssh_message | msg | ) |

Reply with a standard reject message.

Use this function if you don't know what to respond or if you want to reject a request.

Parameters

  [in] | msg | The message to use for the reply.

Returns
  0 on success, -1 on error.

See also
  ssh_message_get()

## ◆ ssh_message_service_reply_success()

int ssh_message_service_reply_success | ( | ssh_message | msg | ) |

Sends SSH2_MSG_SERVICE_ACCEPT to the client.

Parameters

  msg | The message to reply to

Returns
  SSH_OK when success otherwise SSH_ERROR

## ◆ ssh_message_service_service()

const char * ssh_message_service_service | ( | ssh_message | msg | ) |

Gets the service name from the service request message.

Parameters

  msg | The service request message

Returns
  the service name from the message

## ◆ ssh_send_issue_banner()

int ssh_send_issue_banner | ( | ssh_session | session,
|  | const ssh_string | banner )

Send the server's issue-banner to client.

Parameters

  [in] | session | The server session.
  [in] | banner | The server's banner.

Returns
  SSH_OK on success, SSH_ERROR on error.

## ◆ ssh_send_keepalive()

int ssh_send_keepalive | ( | ssh_session | session | ) |

Sends a keepalive message to the session.

Parameters

  session | The session to send the message to

Returns
  SSH_OK

## ◆ ssh_server_init_kex()

int ssh_server_init_kex | ( | ssh_session | session | ) |

Initialize the set of key exchange, hostkey, ciphers, MACs, and compression algorithms for the given ssh_session.

The selection of algorithms and keys used are determined by the options that are currently set in the given ssh_session structure. May only be called before the initial key exchange has begun.

Parameters

  session | The session structure to initialize.

See also
  ssh_handle_key_exchange
  ssh_options_set

Returns
  SSH_OK if initialization succeeds.

## ◆ ssh_set_auth_methods()

void ssh_set_auth_methods | ( | ssh_session | session,
|  | int | auth_methods )

Set the acceptable authentication methods to be sent to the client.

Parameters

  [in] | session | The server session
  [in] | auth_methods | The authentication methods we will support, which can be bitwise-or'd.

Supported methods are:

SSH_AUTH_METHOD_PASSWORD SSH_AUTH_METHOD_PUBLICKEY SSH_AUTH_METHOD_HOSTBASED SSH_AUTH_METHOD_INTERACTIVE SSH_AUTH_METHOD_GSSAPI_MIC SSH_AUTH_METHOD_GSSAPI_KEYEX

## ◆ ssh_set_message_callback()

void ssh_set_message_callback | ( | ssh_session | session,
|  | int(* | ssh_bind_message_callback )(ssh_session session, ssh_message msg, void *data),
|  | void * | data )

defines the ssh_message callback

Parameters

  | session | the current ssh session
  [in] | ssh_bind_message_callback | a function pointer to a callback taking the current ssh session and received message as parameters. the function returns 0 if the message has been parsed and treated successfully, 1 otherwise (libssh must take care of the response).
  [in] | data | void pointer to be passed to callback functions